rc.subr revision 123344
198186Sgordon# $NetBSD: rc.subr,v 1.49 2002/05/21 12:31:01 lukem Exp $
298186Sgordon# $FreeBSD: head/etc/rc.subr 123344 2003-12-09 08:51:11Z mtm $
378344Sobrien#
498186Sgordon# Copyright (c) 1997-2002 The NetBSD Foundation, Inc.
578344Sobrien# All rights reserved.
678344Sobrien#
778344Sobrien# This code is derived from software contributed to The NetBSD Foundation
878344Sobrien# by Luke Mewburn.
978344Sobrien#
1078344Sobrien# Redistribution and use in source and binary forms, with or without
1178344Sobrien# modification, are permitted provided that the following conditions
1278344Sobrien# are met:
1378344Sobrien# 1. Redistributions of source code must retain the above copyright
1478344Sobrien#    notice, this list of conditions and the following disclaimer.
1578344Sobrien# 2. Redistributions in binary form must reproduce the above copyright
1678344Sobrien#    notice, this list of conditions and the following disclaimer in the
1778344Sobrien#    documentation and/or other materials provided with the distribution.
1878344Sobrien# 3. All advertising materials mentioning features or use of this software
1978344Sobrien#    must display the following acknowledgement:
2078344Sobrien#        This product includes software developed by the NetBSD
2178344Sobrien#        Foundation, Inc. and its contributors.
2278344Sobrien# 4. Neither the name of The NetBSD Foundation nor the names of its
2378344Sobrien#    contributors may be used to endorse or promote products derived
2478344Sobrien#    from this software without specific prior written permission.
2578344Sobrien#
2678344Sobrien# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
2778344Sobrien# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
2878344Sobrien# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
2978344Sobrien# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
3078344Sobrien# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
3178344Sobrien# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
3278344Sobrien# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
3378344Sobrien# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
3478344Sobrien# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
3578344Sobrien# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
3678344Sobrien# POSSIBILITY OF SUCH DAMAGE.
3778344Sobrien#
3878344Sobrien# rc.subr
3978344Sobrien#	functions used by various rc scripts
4078344Sobrien#
4178344Sobrien
4278344Sobrien#
4398186Sgordon#	Operating System dependent/independent variables
4498186Sgordon#
4598186Sgordon
4698186SgordonSYSCTL="/sbin/sysctl"
4798186SgordonSYSCTL_N="${SYSCTL} -n"
4898186SgordonCMD_OSTYPE="${SYSCTL_N} kern.ostype"
49103018SgordonOSTYPE=`${CMD_OSTYPE}`
5098186Sgordon
51103018Sgordoncase ${OSTYPE} in
5298186SgordonFreeBSD)
5398186Sgordon	SYSCTL_W="${SYSCTL}"
5498186Sgordon	;;
5598186SgordonNetBSD)
5698186Sgordon	SYSCTL_W="${SYSCTL} -w"
5798186Sgordon	;;
5898186Sgordonesac
5998186Sgordon
6098186Sgordon#
6178344Sobrien#	functions
6278344Sobrien#	---------
6378344Sobrien
6478344Sobrien#
6598186Sgordon# set_rcvar base_var
6698186Sgordon#	Set the variable name enabling a specific service.
6798186Sgordon#	FreeBSD uses ${service}_enable, while NetBSD uses
6898186Sgordon#	just the name of the service. For example:
6998186Sgordon#	FreeBSD: sendmail_enable="YES"
7098186Sgordon#	NetBSD : sendmail="YES"
7198186Sgordon#	$1 - if $name is not the base to work of off, specify
7298186Sgordon#	     a different one
7398186Sgordon#
7498186Sgordonset_rcvar()
7598186Sgordon{
7698186Sgordon	if [ -z "$1" ]; then
7798186Sgordon		base_var=${name}
7898186Sgordon	else
7998186Sgordon		base_var="$1"
8098186Sgordon	fi
8198186Sgordon
82103018Sgordon	case ${OSTYPE} in
8398186Sgordon	FreeBSD)
8498186Sgordon		echo ${base_var}_enable
8598186Sgordon		;;
8698186Sgordon	NetBSD)
8798186Sgordon		echo ${base_var}
8898186Sgordon		;;
8998186Sgordon	*)
9098186Sgordon		echo 'XXX'
9198186Sgordon		;;
9298186Sgordon	esac
9398186Sgordon}
9498186Sgordon
9598186Sgordon#
9698186Sgordon# force_depend script
9798186Sgordon#	Force a service to start. Intended for use by services
9898186Sgordon#	to resolve dependency issues. It is assumed the caller
9998186Sgordon#	has check to make sure this call is necessary
10098186Sgordon#	$1 - filename of script, in /etc/rc.d, to run
10198186Sgordon#
10298186Sgordonforce_depend()
10398186Sgordon{
10498186Sgordon	_depend="$1"
10598186Sgordon
10698186Sgordon	info "${name} depends on ${_depend}, which will be forced to start."
10798186Sgordon	if ! /etc/rc.d/${_depend} forcestart ; then
10898186Sgordon		warn "Unable to force ${_depend}. It may already be running."
10998186Sgordon		return 1
11098186Sgordon	fi
11198186Sgordon	return 0
11298186Sgordon}
11398186Sgordon
11498186Sgordon#
11578344Sobrien# checkyesno var
11678344Sobrien#	Test $1 variable, and warn if not set to YES or NO.
11778344Sobrien#	Return 0 if it's "yes" (et al), nonzero otherwise.
11878344Sobrien#
11978344Sobriencheckyesno()
12078344Sobrien{
12178344Sobrien	eval _value=\$${1}
12298186Sgordon	debug "checkyesno: $1 is set to $_value."
12378344Sobrien	case $_value in
12478344Sobrien
12578344Sobrien		#	"yes", "true", "on", or "1"
12678344Sobrien	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
12778344Sobrien		return 0
12878344Sobrien		;;
12978344Sobrien
13078344Sobrien		#	"no", "false", "off", or "0"
13178344Sobrien	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
13278344Sobrien		return 1
13378344Sobrien		;;
13478344Sobrien	*)
135106643Sgordon		warn "\$${1} is not set properly - see rc.conf(5)."
13678344Sobrien		return 1
13778344Sobrien		;;
13878344Sobrien	esac
13978344Sobrien}
14078344Sobrien
14198186Sgordon# reverse_list list
14298186Sgordon#	print the list in reverse order
14378344Sobrien#
14498186Sgordonreverse_list()
14598186Sgordon{
14698186Sgordon	_revlist=
14798186Sgordon	for _revfile in $*; do
14898186Sgordon		_revlist="$_revfile $_revlist"
14998186Sgordon	done
15098186Sgordon	echo $_revlist
15198186Sgordon}
15298186Sgordon
15378344Sobrien#
15498186Sgordon# mount_critical_filesystems type
15598186Sgordon#	Go through the list of critical filesystems as provided in
15698186Sgordon#	the rc.conf(5) variable $critical_filesystems_${type}, checking
15798186Sgordon#	each one to see if it is mounted, and if it is not, mounting it.
15898186Sgordon#
15978344Sobrienmount_critical_filesystems()
16078344Sobrien{
16198186Sgordon	eval _fslist=\$critical_filesystems_${1}
16278344Sobrien	for _fs in $_fslist; do
16378344Sobrien		mount | (
16478344Sobrien			_ismounted=no
16578344Sobrien			while read what _on on _type type; do
16678344Sobrien				if [ $on = $_fs ]; then
16778344Sobrien					_ismounted=yes
16878344Sobrien				fi
16978344Sobrien			done
17098186Sgordon			if [ $_ismounted = no ]; then
17178344Sobrien				mount $_fs >/dev/null 2>&1
17278344Sobrien			fi
17398186Sgordon		)
17478344Sobrien	done
17578344Sobrien}
17678344Sobrien
17778344Sobrien#
17898186Sgordon# check_pidfile pidfile procname [interpreter]
17998186Sgordon#	Parses the first line of pidfile for a PID, and ensures
18078344Sobrien#	that the process is running and matches procname.
18198186Sgordon#	Prints the matching PID upon success, nothing otherwise.
18298186Sgordon#	interpreter is optional; see _find_processes() for details.
18378344Sobrien#
18478344Sobriencheck_pidfile()
18578344Sobrien{
18678344Sobrien	_pidfile=$1
18778344Sobrien	_procname=$2
18898186Sgordon	_interpreter=$3
18978344Sobrien	if [ -z "$_pidfile" -o -z "$_procname" ]; then
19098186Sgordon		err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
19178344Sobrien	fi
19278344Sobrien	if [ ! -f $_pidfile ]; then
19398186Sgordon		debug "pid file {$_pidfile): not readable."
19478344Sobrien		return
19578344Sobrien	fi
19678344Sobrien	read _pid _junk < $_pidfile
19778344Sobrien	if [ -z "$_pid" ]; then
19898186Sgordon		debug "pid file {$_pidfile): no pid in file."
19978344Sobrien		return
20078344Sobrien	fi
20198186Sgordon	_find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
20278344Sobrien}
20378344Sobrien
20478344Sobrien#
20598186Sgordon# check_process procname [interpreter]
20678344Sobrien#	Ensures that a process (or processes) named procname is running.
20798186Sgordon#	Prints a list of matching PIDs.
20898186Sgordon#	interpreter is optional; see _find_processes() for details.
20978344Sobrien#
21078344Sobriencheck_process()
21178344Sobrien{
21278344Sobrien	_procname=$1
21398186Sgordon	_interpreter=$2
21478344Sobrien	if [ -z "$_procname" ]; then
21598186Sgordon		err 3 'USAGE: check_process procname [interpreter]'
21678344Sobrien	fi
21798186Sgordon	_find_processes $_procname ${_interpreter:-.} '-ax'
21898186Sgordon}
21998186Sgordon
22098186Sgordon#
22198186Sgordon# _find_processes procname interpreter psargs
22298186Sgordon#	Search for procname in the output of ps generated by psargs.
22398186Sgordon#	Prints the PIDs of any matching processes, space separated.
22498186Sgordon#
22598186Sgordon#	If interpreter == ".", check the following variations of procname
22698186Sgordon#	against the first word of each command:
22798186Sgordon#		procname
22898186Sgordon#		`basename procname`
22998186Sgordon#		`basename procname` + ":"
23098186Sgordon#		"(" + `basename procname` + ")"
23198186Sgordon#
23298186Sgordon#	If interpreter != ".", read the first line of procname, remove the
23398186Sgordon#	leading #!, normalise whitespace, append procname, and attempt to
23498186Sgordon#	match that against each command, either as is, or with extra words
23598186Sgordon#	at the end.
23698186Sgordon#
23798186Sgordon_find_processes()
23898186Sgordon{
23998186Sgordon	if [ $# -ne 3 ]; then
24098186Sgordon		err 3 'USAGE: _find_processes procname interpreter psargs'
24198186Sgordon	fi
24298186Sgordon	_procname=$1
24398186Sgordon	_interpreter=$2
24498186Sgordon	_psargs=$3
24598186Sgordon
24678344Sobrien	_pref=
24798186Sgordon	if [ $_interpreter != "." ]; then	# an interpreted script
24898186Sgordon		read _interp < $_procname	# read interpreter name
24998186Sgordon		_interp=${_interp#\#!}		# strip #!
25098186Sgordon		set -- $_interp
25198186Sgordon		if [ $_interpreter != $1 ]; then
25298186Sgordon			warn "\$command_interpreter $_interpreter != $1"
25378344Sobrien		fi
25498186Sgordon		_interp="$* $_procname"		# cleanup spaces, add _procname
25598186Sgordon		_fp_args='_argv'
25698186Sgordon		_fp_match='case "$_argv" in
25798186Sgordon		    ${_interp}|"${_interp} "*)'
25898186Sgordon	else					# a normal daemon
25998186Sgordon		_procnamebn=${_procname##*/}
26098186Sgordon		_fp_args='_arg0 _argv'
26198186Sgordon		_fp_match='case "$_arg0" in
26298186Sgordon		    $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})")'
26398186Sgordon	fi
26498186Sgordon
26598186Sgordon	_proccheck='
26698186Sgordon		ps -o "pid,command" '"$_psargs"' |
26798186Sgordon		while read _npid '"$_fp_args"'; do
26898186Sgordon			case "$_npid" in
26998186Sgordon			    PID)
27098186Sgordon				continue ;;
27198186Sgordon			esac ; '"$_fp_match"'
27298186Sgordon				echo -n "$_pref$_npid" ;
27398186Sgordon				_pref=" "
27498186Sgordon				;;
27598186Sgordon			esac
27698186Sgordon		done'
27798186Sgordon
278114272Smtm#	debug "in _find_processes: proccheck is ($_proccheck)."
27998186Sgordon	eval $_proccheck
28098186Sgordon}
28198186Sgordon
28298186Sgordon#
28398186Sgordon# wait_for_pids pid [pid ...]
28498186Sgordon#	spins until none of the pids exist
28598186Sgordon#
28698186Sgordonwait_for_pids()
28798186Sgordon{
28898186Sgordon	_list=$*
28998186Sgordon	if [ -z "$_list" ]; then
29098186Sgordon		return
29198186Sgordon	fi
29298186Sgordon	_prefix=
29398186Sgordon	while true; do
29498186Sgordon		_nlist="";
29598186Sgordon		for _j in $_list; do
29698186Sgordon			if kill -0 $_j 2>/dev/null; then
29798186Sgordon				_nlist="${_nlist}${_nlist:+ }$_j"
29898186Sgordon			fi
29998186Sgordon		done
30098186Sgordon		if [ -z "$_nlist" ]; then
30198186Sgordon			break
30278344Sobrien		fi
30398186Sgordon		_list=$_nlist
30498186Sgordon		echo -n ${_prefix:-"Waiting for PIDS: "}$_list
30598186Sgordon		_prefix=", "
30698186Sgordon		sleep 2
30778344Sobrien	done
30898186Sgordon	if [ -n "$_prefix" ]; then
30998186Sgordon		echo "."
31098186Sgordon	fi
31178344Sobrien}
31278344Sobrien
31378344Sobrien#
31498186Sgordon# run_rc_command argument
31598186Sgordon#	Search for argument in the list of supported commands, which is:
31698186Sgordon#		"start stop restart rcvar status poll ${extra_commands}"
31798186Sgordon#	If there's a match, run ${argument}_cmd or the default method
31898186Sgordon#	(see below).
31978344Sobrien#
32098186Sgordon#	If argument has a given prefix, then change the operation as follows:
32198186Sgordon#		Prefix	Operation
32278344Sobrien#		------	---------
32398186Sgordon#		fast	Skip the pid check, and set rc_fast=yes
32498186Sgordon#		force	Set ${rcvar} to YES, and set rc_force=yes
32578344Sobrien#
32678344Sobrien#	The following globals are used:
32778344Sobrien#
32898186Sgordon#	Name		Needed	Purpose
32998186Sgordon#	----		------	-------
33078344Sobrien#	name		y	Name of script.
33178344Sobrien#
33278344Sobrien#	command		n	Full path to command.
33398186Sgordon#				Not needed if ${rc_arg}_cmd is set for
33478344Sobrien#				each keyword.
33578344Sobrien#
33678344Sobrien#	command_args	n	Optional args/shell directives for command.
33778344Sobrien#
33898186Sgordon#	command_interpreter n	If not empty, command is interpreted, so
33998186Sgordon#				call check_{pidfile,process}() appropriately.
34098186Sgordon#
34178344Sobrien#	extra_commands	n	List of extra commands supported.
34278344Sobrien#
34398186Sgordon#	pidfile		n	If set, use check_pidfile $pidfile $command,
34498186Sgordon#				otherwise use check_process $command.
34598186Sgordon#				In either case, only check if $command is set.
34678344Sobrien#
34798186Sgordon#	procname	n	Process name to check for instead of $command.
34898186Sgordon#
34978344Sobrien#	rcvar		n	This is checked with checkyesno to determine
35078344Sobrien#				if the action should be run.
35178344Sobrien#
35278344Sobrien#	${name}_chroot	n	Directory to chroot to before running ${command}
35398186Sgordon#				Requires /usr to be mounted.
35478344Sobrien#
35578344Sobrien#	${name}_chdir	n	Directory to cd to before running ${command}
35678344Sobrien#				(if not using ${name}_chroot).
35778344Sobrien#
35878344Sobrien#	${name}_flags	n	Arguments to call ${command} with.
35978344Sobrien#				NOTE:	$flags from the parent environment
36078344Sobrien#					can be used to override this.
36178344Sobrien#
36278344Sobrien#	${name}_nice	n	Nice level to run ${command} at.
36378344Sobrien#
36478344Sobrien#	${name}_user	n	User to run ${command} as, using su(1) if not
36578344Sobrien#				using ${name}_chroot.
36698186Sgordon#				Requires /usr to be mounted.
36778344Sobrien#
36878344Sobrien#	${name}_group	n	Group to run chrooted ${command} as.
36998186Sgordon#				Requires /usr to be mounted.
37078344Sobrien#
37198186Sgordon#	${name}_groups	n	Comma separated list of supplementary groups
37298186Sgordon#				to run the chrooted ${command} with.
37398186Sgordon#				Requires /usr to be mounted.
37478344Sobrien#
37598186Sgordon#	${rc_arg}_cmd	n	If set, use this as the method when invoked;
37678344Sobrien#				Otherwise, use default command (see below)
37778344Sobrien#
37898186Sgordon#	${rc_arg}_precmd n	If set, run just before performing the
37998186Sgordon#				${rc_arg}_cmd method in the default
38098186Sgordon#				operation (i.e, after checking for required
38198186Sgordon#				bits and process (non)existence).
38278344Sobrien#				If this completes with a non-zero exit code,
38398186Sgordon#				don't run ${rc_arg}_cmd.
38478344Sobrien#
38598186Sgordon#	${rc_arg}_postcmd n	If set, run just after performing the
38698186Sgordon#				${rc_arg}_cmd method, if that method
38798186Sgordon#				returned a zero exit code.
38898186Sgordon#
38978344Sobrien#	required_dirs	n	If set, check for the existence of the given
39078344Sobrien#				directories before running the default
39178344Sobrien#				(re)start command.
39278344Sobrien#
39378344Sobrien#	required_files	n	If set, check for the readability of the given
39478344Sobrien#				files before running the default (re)start
39578344Sobrien#				command.
39678344Sobrien#
39778344Sobrien#	required_vars	n	If set, perform checkyesno on each of the
39878344Sobrien#				listed variables before running the default
39978344Sobrien#				(re)start command.
40078344Sobrien#
40198186Sgordon#	Default behaviour for a given argument, if no override method is
40298186Sgordon#	provided:
40378344Sobrien#
40498186Sgordon#	Argument	Default behaviour
40598186Sgordon#	--------	-----------------
40678344Sobrien#	start		if !running && checkyesno ${rcvar}
40778344Sobrien#				${command}
40878344Sobrien#
40978344Sobrien#	stop		if ${pidfile}
41098186Sgordon#				rc_pid=$(check_pidfile $pidfile $command)
41178344Sobrien#			else
41298186Sgordon#				rc_pid=$(check_process $command)
41398186Sgordon#			kill $sig_stop $rc_pid
41498186Sgordon#			wait_for_pids $rc_pid
41598186Sgordon#			($sig_stop defaults to TERM.)
41678344Sobrien#
41798186Sgordon#	reload		Similar to stop, except use $sig_reload instead,
41898186Sgordon#			and doesn't wait_for_pids.
41978344Sobrien#			$sig_reload defaults to HUP.
42078344Sobrien#
42178344Sobrien#	restart		Run `stop' then `start'.
42278344Sobrien#
42398186Sgordon#	status		Show if ${command} is running, etc.
42478344Sobrien#
42598186Sgordon#	poll		Wait for ${command} to exit.
42698186Sgordon#
42798186Sgordon#	rcvar		Display what rc.conf variable is used (if any).
42898186Sgordon#
42998186Sgordon#	Variables available to methods, and after run_rc_command() has
43098186Sgordon#	completed:
43198186Sgordon#
43298186Sgordon#	Variable	Purpose
43398186Sgordon#	--------	-------
43498186Sgordon#	rc_arg		Argument to command, after fast/force processing
43598186Sgordon#			performed
43698186Sgordon#
43798186Sgordon#	rc_flags	Flags to start the default command with.
43898186Sgordon#			Defaults to ${name}_flags, unless overridden
43998186Sgordon#			by $flags from the environment.
44098186Sgordon#			This variable may be changed by the precmd method.
44198186Sgordon#
44298186Sgordon#	rc_pid		PID of command (if appropriate)
44398186Sgordon#
44498186Sgordon#	rc_fast		Not empty if "fast" was provided (q.v.)
44598186Sgordon#
44698186Sgordon#	rc_force	Not empty if "force" was provided (q.v.)
44798186Sgordon#
44898186Sgordon#
44978344Sobrienrun_rc_command()
45078344Sobrien{
451116097Smtm	_return=0
45298186Sgordon	rc_arg=$1
45378344Sobrien	if [ -z "$name" ]; then
45498186Sgordon		err 3 'run_rc_command: $name is not set.'
45578344Sobrien	fi
45678344Sobrien
45798186Sgordon	case "$rc_arg" in
45878344Sobrien	fast*)				# "fast" prefix; don't check pid
45998186Sgordon		rc_arg=${rc_arg#fast}
46098186Sgordon		rc_fast=yes
46178344Sobrien		;;
46278344Sobrien	force*)				# "force prefix; always start
46398186Sgordon		rc_arg=${rc_arg#force}
46498186Sgordon		rc_force=yes
46578344Sobrien		if [ -n "${rcvar}" ]; then
46678344Sobrien			eval ${rcvar}=YES
46778344Sobrien		fi
46878344Sobrien		;;
46978344Sobrien	esac
47078344Sobrien
47198186Sgordon	eval _overide_command=\$${name}_program
47298186Sgordon	if [ -n "$_overide_command" ]; then
47398186Sgordon		command=$_overide_command
47498186Sgordon	fi
47598186Sgordon
47678344Sobrien	_keywords="start stop restart rcvar $extra_commands"
47798186Sgordon	rc_pid=
47878344Sobrien	_pidcmd=
47998186Sgordon	_procname=${procname:-${command}}
48098186Sgordon
48178344Sobrien					# setup pid check command if not fast
48298186Sgordon	if [ -z "$rc_fast" -a -n "$_procname" ]; then
48378344Sobrien		if [ -n "$pidfile" ]; then
48498186Sgordon			_pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
48598186Sgordon		else
48698186Sgordon			_pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
48778344Sobrien		fi
48878344Sobrien		if [ -n "$_pidcmd" ]; then
48998186Sgordon			_keywords="${_keywords} status poll"
49078344Sobrien		fi
49178344Sobrien	fi
49278344Sobrien
49398186Sgordon	if [ -z "$rc_arg" ]; then
49478344Sobrien		rc_usage "$_keywords"
49578344Sobrien	fi
49678344Sobrien
49778344Sobrien	if [ -n "$flags" ]; then	# allow override from environment
49898186Sgordon		rc_flags=$flags
49978344Sobrien	else
50098186Sgordon		eval rc_flags=\$${name}_flags
50178344Sobrien	fi
50298186Sgordon	eval _chdir=\$${name}_chdir	_chroot=\$${name}_chroot \
50398186Sgordon	    _nice=\$${name}_nice	_user=\$${name}_user \
50498186Sgordon	    _group=\$${name}_group	_groups=\$${name}_groups
50578344Sobrien
50698186Sgordon	if [ -n "$_user" ]; then	# unset $_user if running as that user
50798186Sgordon		if [ "$_user" = "$(id -un)" ]; then
50898186Sgordon			unset _user
50998186Sgordon		fi
51098186Sgordon	fi
51198186Sgordon
51278344Sobrien					# if ${rcvar} is set, and $1 is not
51398186Sgordon					# "rcvar", then run
51478344Sobrien					#	checkyesno ${rcvar}
51578344Sobrien					# and return if that failed
51678344Sobrien					#
51798186Sgordon	if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" ]; then
51878344Sobrien		if ! checkyesno ${rcvar}; then
51978344Sobrien			return 0
52078344Sobrien		fi
52178344Sobrien	fi
52278344Sobrien
52378344Sobrien	eval $_pidcmd			# determine the pid if necessary
52478344Sobrien
52578344Sobrien	for _elem in $_keywords; do
52698186Sgordon		if [ "$_elem" != "$rc_arg" ]; then
52778344Sobrien			continue
52878344Sobrien		fi
52978344Sobrien
53078344Sobrien					# if there's a custom ${XXX_cmd},
53178344Sobrien					# run that instead of the default
53278344Sobrien					#
53398186Sgordon		eval _cmd=\$${rc_arg}_cmd _precmd=\$${rc_arg}_precmd \
53498186Sgordon		    _postcmd=\$${rc_arg}_postcmd
53578344Sobrien		if [ -n "$_cmd" ]; then
53678344Sobrien					# if the precmd failed and force
53778344Sobrien					# isn't set, exit
53878344Sobrien					#
539116097Smtm			if [ -n "$_precmd" ]; then
540116097Smtm				debug "run_rc_command: evaluating ${_precmd}()."
541116097Smtm				eval $_precmd
542116097Smtm				_return=$?
543116097Smtm				[ $_return -ne 0 ] && [ -z "$rc_force" ] &&
544116097Smtm				    return 1
54578344Sobrien			fi
54678344Sobrien
547116097Smtm			if [ -n "$_cmd" ]; then
548116097Smtm				debug "run_rc_command: evaluating ${_cmd}()."
549116097Smtm				eval $_cmd
550116097Smtm				_return=$?
551116097Smtm				[ $_return -ne 0 ] && [ -z "$rc_force" ] &&
552116097Smtm				    return 1
55398186Sgordon			fi
554109582Smtm
555116097Smtm			if [ -n "$_postcmd" ]; then
556116097Smtm				debug "run_rc_command: evaluating ${_postcmd}()."
557116097Smtm				 eval $_postcmd
558116097Smtm				_return=$?
559116097Smtm			fi
560116097Smtm			return $_return
56178344Sobrien		fi
56278344Sobrien
56398186Sgordon		case "$rc_arg" in	# default operations...
56478344Sobrien
56578344Sobrien		status)
56698186Sgordon			if [ -n "$rc_pid" ]; then
56798186Sgordon				echo "${name} is running as pid $rc_pid."
56878344Sobrien			else
56978344Sobrien				echo "${name} is not running."
57078344Sobrien				return 1
57178344Sobrien			fi
57278344Sobrien			;;
57378344Sobrien
57478344Sobrien		start)
57598186Sgordon			if [ -n "$rc_pid" ]; then
57698186Sgordon				echo "${name} already running? (pid=$rc_pid)."
57778344Sobrien				exit 1
57878344Sobrien			fi
57978344Sobrien
58078344Sobrien			if [ ! -x $command ]; then
58198186Sgordon				info "run_rc_command: cannot run ($command)."
58278344Sobrien				return 0
58378344Sobrien			fi
58478344Sobrien
58578344Sobrien					# check for required variables,
58678344Sobrien					# directories, and files
58778344Sobrien					#
58878344Sobrien			for _f in $required_vars; do
58978344Sobrien				if ! checkyesno $_f; then
59078344Sobrien					warn "\$${_f} is not set."
59198186Sgordon					if [ -z "$rc_force" ]; then
59278344Sobrien						return 1
59378344Sobrien					fi
59478344Sobrien				fi
59578344Sobrien			done
59678344Sobrien			for _f in $required_dirs; do
59778344Sobrien				if [ ! -d "${_f}/." ]; then
59878344Sobrien					warn "${_f} is not a directory."
59998186Sgordon					if [ -z "$rc_force" ]; then
60078344Sobrien						return 1
60178344Sobrien					fi
60278344Sobrien				fi
60378344Sobrien			done
60478344Sobrien			for _f in $required_files; do
60578344Sobrien				if [ ! -r "${_f}" ]; then
60678344Sobrien					warn "${_f} is not readable."
60798186Sgordon					if [ -z "$rc_force" ]; then
60878344Sobrien						return 1
60978344Sobrien					fi
61078344Sobrien				fi
61178344Sobrien			done
61278344Sobrien
61378344Sobrien					# if the precmd failed and force
61478344Sobrien					# isn't set, exit
61578344Sobrien					#
616116097Smtm			if [ -n "${_precmd}" ]; then
617116097Smtm				debug "run_rc_command: evaluating ${_precmd}()."
618116097Smtm				eval $_precmd
619116097Smtm				_return=$?
620116097Smtm				[ $_return -ne 0 ] && [ -z "$rc_force" ] &&
621116097Smtm				    return 1
62278344Sobrien			fi
62378344Sobrien
62478344Sobrien					# setup the command to run, and run it
62578344Sobrien					#
62678344Sobrien			echo "Starting ${name}."
62778344Sobrien			if [ -n "$_chroot" ]; then
62878344Sobrien				_doit="\
62978344Sobrien${_nice:+nice -n $_nice }\
63078344Sobrienchroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
63198186Sgordon$_chroot $command $rc_flags $command_args"
63278344Sobrien			else
63378344Sobrien				_doit="\
63478344Sobrien${_chdir:+cd $_chdir; }\
63578344Sobrien${_nice:+nice -n $_nice }\
63698186Sgordon$command $rc_flags $command_args"
63798186Sgordon				if [ -n "$_user" ]; then
63898186Sgordon				    _doit="su -m $_user -c 'sh -c \"$_doit\"'"
63998186Sgordon				fi
64078344Sobrien			fi
64198186Sgordon
64298186Sgordon					# if the cmd failed and force
64398186Sgordon					# isn't set, exit
64498186Sgordon					#
64598186Sgordon			debug "run_rc_command: _doit: $_doit"
646116097Smtm			eval $_doit
647116097Smtm			_return=$?
648116097Smtm			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
64998186Sgordon
65098186Sgordon					# finally, run postcmd
65198186Sgordon					#
652116097Smtm			if [ -n "${_postcmd}" ]; then
653116097Smtm				debug "run_rc_command: evaluating ${_postcmd}()."
654116097Smtm				eval $_postcmd
655116097Smtm			fi
65678344Sobrien			;;
65778344Sobrien
65878344Sobrien		stop)
65998186Sgordon			if [ -z "$rc_pid" ]; then
66078344Sobrien				if [ -n "$pidfile" ]; then
66178344Sobrien					echo \
66278344Sobrien				    "${name} not running? (check $pidfile)."
66378344Sobrien				else
66478344Sobrien					echo "${name} not running?"
66578344Sobrien				fi
66678344Sobrien				exit 1
66778344Sobrien			fi
66878344Sobrien
66998186Sgordon					# if the precmd failed and force
67098186Sgordon					# isn't set, exit
67198186Sgordon					#
672117977Smtm			if [ -n "$_precmd" ]; then
673116097Smtm				eval $_precmd
674116097Smtm				_return=$?
675116097Smtm				[ $_return -ne 0 ] && [ -z "$rc_force" ] &&
676116097Smtm				    return 1
67778344Sobrien			fi
67898186Sgordon
67998186Sgordon					# send the signal to stop
68098186Sgordon					#
68178344Sobrien			echo "Stopping ${name}."
68298186Sgordon			_doit="kill -${sig_stop:-TERM} $rc_pid"
68398186Sgordon			if [ -n "$_user" ]; then
68498186Sgordon				_doit="su -m $_user -c 'sh -c \"$_doit\"'"
68598186Sgordon			fi
68698186Sgordon
68798186Sgordon					# if the stop cmd failed and force
68898186Sgordon					# isn't set, exit
68998186Sgordon					#
690116097Smtm			eval $_doit
691116097Smtm			_return=$?
692116097Smtm			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
69398186Sgordon
69498186Sgordon					# wait for the command to exit,
69598186Sgordon					# and run postcmd.
69698186Sgordon			wait_for_pids $rc_pid
697116097Smtm			if [ -n "$_postcmd" ]; then
698116097Smtm				eval $_postcmd
699116097Smtm				_return=$?
700116097Smtm			fi
70178344Sobrien			;;
70278344Sobrien
70378344Sobrien		reload)
70498186Sgordon			if [ -z "$rc_pid" ]; then
70578344Sobrien				if [ -n "$pidfile" ]; then
70678344Sobrien					echo \
70778344Sobrien				    "${name} not running? (check $pidfile)."
70878344Sobrien				else
70978344Sobrien					echo "${name} not running?"
71078344Sobrien				fi
71178344Sobrien				exit 1
71278344Sobrien			fi
71378344Sobrien			echo "Reloading ${name} config files."
714116097Smtm			if [ -n "$_precmd" ]; then
715116097Smtm				eval $_precmd
716116097Smtm				_return=$?
717116097Smtm				[ $_return -ne 0 ] && [ -z "$rc_force" ] &&
718116097Smtm				    return 1
71978344Sobrien			fi
72098186Sgordon			_doit="kill -${sig_reload:-HUP} $rc_pid"
72198186Sgordon			if [ -n "$_user" ]; then
72298186Sgordon				_doit="su -m $_user -c 'sh -c \"$_doit\"'"
72398186Sgordon			fi
724116097Smtm			eval $_doit
725116097Smtm			_return=$?
726116097Smtm			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
727116097Smtm			if [ -n "$_postcmd" ]; then
728116097Smtm				eval $_postcmd
729116097Smtm				_return=$?
73098186Sgordon			fi
73178344Sobrien			;;
73278344Sobrien
73378344Sobrien		restart)
734116097Smtm			if [ -n "$_precmd" ]; then
735116097Smtm				eval $_precmd
736116097Smtm				_return=$?
737116097Smtm				[ $_return -ne 0 ] && [ -z "$rc_force" ] &&
738116097Smtm				    return 1
73978344Sobrien			fi
74078344Sobrien					# prevent restart being called more
74178344Sobrien					# than once by any given script
74278344Sobrien					#
74378344Sobrien			if [ -n "$_rc_restart_done" ]; then
74478344Sobrien				return 0
74578344Sobrien			fi
74678344Sobrien			_rc_restart_done=YES
74778344Sobrien
74898186Sgordon			( $0 ${rc_force:+force}stop )
74998186Sgordon			$0 ${rc_force:+force}start
75098186Sgordon
751116097Smtm			if [ -n "$_postcmd" ]; then
752116097Smtm				eval $_postcmd
753116097Smtm				_return=$?
754116097Smtm			fi
75578344Sobrien			;;
75678344Sobrien
75798186Sgordon		poll)
75898186Sgordon			if [ -n "$rc_pid" ]; then
75998186Sgordon				wait_for_pids $rc_pid
76098186Sgordon			fi
76198186Sgordon			;;
76298186Sgordon
76378344Sobrien		rcvar)
76478344Sobrien			echo "# $name"
76578344Sobrien			if [ -n "$rcvar" ]; then
76678344Sobrien				if checkyesno ${rcvar}; then
76778344Sobrien					echo "\$${rcvar}=YES"
76878344Sobrien				else
76978344Sobrien					echo "\$${rcvar}=NO"
77078344Sobrien				fi
77178344Sobrien			fi
77278344Sobrien			;;
77378344Sobrien
77478344Sobrien		*)
77578344Sobrien			rc_usage "$_keywords"
77678344Sobrien			;;
77778344Sobrien
77878344Sobrien		esac
779116097Smtm		return $_return
78078344Sobrien	done
78178344Sobrien
78298186Sgordon	echo 1>&2 "$0: unknown directive '$rc_arg'."
78378344Sobrien	rc_usage "$_keywords"
78478344Sobrien	exit 1
78578344Sobrien}
78678344Sobrien
78778344Sobrien#
78878344Sobrien# run_rc_script file arg
78978344Sobrien#	Start the script `file' with `arg', and correctly handle the
79078344Sobrien#	return value from the script.  If `file' ends with `.sh', it's
79198186Sgordon#	sourced into the current environment.  If `file' appears to be
79298186Sgordon#	a backup or scratch file, ignore it.  Otherwise if it's
79398186Sgordon#	executable run as a child process.
79478344Sobrien#
79578344Sobrienrun_rc_script()
79678344Sobrien{
79778344Sobrien	_file=$1
79878344Sobrien	_arg=$2
79978344Sobrien	if [ -z "$_file" -o -z "$_arg" ]; then
80078344Sobrien		err 3 'USAGE: run_rc_script file arg'
80178344Sobrien	fi
80278344Sobrien
80398186Sgordon	trap "echo 'Reboot interrupted'; exit 1" 3
80498186Sgordon
80598186Sgordon	unset	name command command_args command_interpreter \
80698186Sgordon		extra_commands pidfile procname \
80798186Sgordon		rcvar required_dirs required_files required_vars
80898186Sgordon	eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
80998186Sgordon
81078344Sobrien	case "$_file" in
81178344Sobrien	*.sh)				# run in current shell
81278344Sobrien		set $_arg ; . $_file
81378344Sobrien		;;
81498186Sgordon	*[~#]|*.OLD|*.orig)		# scratch file; skip
81598186Sgordon		warn "Ignoring scratch file $_file"
81698186Sgordon		;;
81778344Sobrien	*)				# run in subshell
81898186Sgordon		if [ -x $_file ]; then
81998186Sgordon			if [ -n "$rc_fast_and_loose" ]; then
82098186Sgordon				set $_arg ; . $_file
82198186Sgordon			else
82298186Sgordon				( trap "echo 'Reboot interrupted'; exit 1" 3
82398186Sgordon				  set $_arg ; . $_file )
82498186Sgordon			fi
82598186Sgordon		fi
82678344Sobrien		;;
82778344Sobrien	esac
82878344Sobrien}
82978344Sobrien
83078344Sobrien#
83178344Sobrien# load_rc_config
83278344Sobrien#	Source in the configuration file for a given command.
83378344Sobrien#
83478344Sobrienload_rc_config()
83578344Sobrien{
83678344Sobrien	_command=$1
83778344Sobrien	if [ -z "$_command" ]; then
83878344Sobrien		err 3 'USAGE: load_rc_config command'
83978344Sobrien	fi
84078344Sobrien
84198186Sgordon	if [ -z "$_rc_conf_loaded" ]; then
84298186Sgordon		if [ -r /etc/defaults/rc.conf ]; then
84398186Sgordon			debug "Sourcing /etc/defaults/rc.conf"
84498186Sgordon			. /etc/defaults/rc.conf
84598186Sgordon			source_rc_confs
84698186Sgordon		elif [ -r /etc/rc.conf ]; then
84798186Sgordon			debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
84898186Sgordon			. /etc/rc.conf
84998186Sgordon		fi
85098186Sgordon		_rc_conf_loaded=YES
85198186Sgordon	fi
85278344Sobrien	if [ -f /etc/rc.conf.d/"$_command" ]; then
85398186Sgordon		debug "Sourcing /etc/rc.conf.d/${_command}"
85478344Sobrien		. /etc/rc.conf.d/"$_command"
85578344Sobrien	fi
856101850Sgordon
857101850Sgordon	# XXX - Deprecated variable name support
858101850Sgordon	#
859103018Sgordon	case ${OSTYPE} in
860101850Sgordon	FreeBSD)
861101850Sgordon        	[ -n "$portmap_enable" ] && rpcbind_enable="$portmap_enable"
862101850Sgordon        	[ -n "$portmap_program" ] && rpcbind_program="$portmap_program"
863101850Sgordon        	[ -n "$portmap_flags" ] && rpcbind_flags="$portmap_flags"
864101850Sgordon        	[ -n "$single_mountd_enable" ] && mountd_enable="$single_mountd_enable"
865101850Sgordon        	[ -n "$xntpd_enable" ] && ntpd_enable="$xntpd_enable"
866101850Sgordon        	[ -n "$xntpd_program" ] && ntpd_program="$xntpd_program"
867101850Sgordon        	[ -n "$xntpd_flags" ] && ntpd_flags="$xntpd_flags"
868115950Smtm		[ -n "$dhcp_program" ] && dhclient_program="$dhcp_program"
869115950Smtm		[ -n "$dhcp_flags" ] && dhclient_flags="$dhcp_flags"
870101850Sgordon        	;;
871101850Sgordon	esac
872101850Sgordon
87378344Sobrien}
87478344Sobrien
87578344Sobrien#
87678344Sobrien# rc_usage commands
87778344Sobrien#	Print a usage string for $0, with `commands' being a list of
87878344Sobrien#	valid commands.
87978344Sobrien#
88078344Sobrienrc_usage()
88178344Sobrien{
882106643Sgordon	echo -n 1>&2 "Usage: $0 [fast|force]("
88378344Sobrien
88478344Sobrien	_sep=
88578344Sobrien	for _elem in $*; do
88678344Sobrien		echo -n 1>&2 "$_sep$_elem"
88778344Sobrien		_sep="|"
88878344Sobrien	done
88978344Sobrien	echo 1>&2 ")"
89078344Sobrien	exit 1
89178344Sobrien}
89278344Sobrien
89378344Sobrien#
89478344Sobrien# err exitval message
89578344Sobrien#	Display message to stderr and log to the syslog, and exit with exitval.
89678344Sobrien#
89778344Sobrienerr()
89878344Sobrien{
89978344Sobrien	exitval=$1
90078344Sobrien	shift
90178344Sobrien
902106643Sgordon	if [ -x /usr/bin/logger ]; then
903106643Sgordon		logger "$0: ERROR: $*"
904106643Sgordon	fi
905106643Sgordon	echo 1>&2 "$0: ERROR: $*"
90678344Sobrien	exit $exitval
90778344Sobrien}
90878344Sobrien
90978344Sobrien#
91078344Sobrien# warn message
91178344Sobrien#	Display message to stderr and log to the syslog.
91278344Sobrien#
91378344Sobrienwarn()
91478344Sobrien{
915106643Sgordon	if [ -x /usr/bin/logger ]; then
916106643Sgordon		logger "$0: WARNING: $*"
917106643Sgordon	fi
918106643Sgordon	echo 1>&2 "$0: WARNING: $*"
91978344Sobrien}
92098186Sgordon
92198186Sgordon#
92298186Sgordon# info message
92398186Sgordon#	Display informational message to stdout and log to syslog.
92498186Sgordon#
92598186Sgordoninfo()
92698186Sgordon{
927119170Smtm	case ${rc_info} in
928119170Smtm	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
929119170Smtm		if [ -x /usr/bin/logger ]; then
930119170Smtm			logger "$0: INFO: $*"
931119170Smtm		fi
932119170Smtm		echo "$0: INFO: $*"
933119170Smtm		;;
934119170Smtm	esac
93598186Sgordon}
93698186Sgordon
93798186Sgordon#
93898186Sgordon# debug message
939106643Sgordon#	If debugging is enabled in rc.conf output message to stderr.
94098186Sgordon#	BEWARE that you don't call any subroutine that itself calls this
94198186Sgordon#	function.
94298186Sgordon#
94398186Sgordondebug()
94498186Sgordon{
94598186Sgordon	case ${rc_debug} in
94698186Sgordon	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
947106700Sgordon		if [ -x /usr/bin/logger ]; then
948106700Sgordon			logger "$0: INFO: $*"
949106700Sgordon		fi
950106643Sgordon        	echo 1>&2 "$0: DEBUG: $*"
95198186Sgordon		;;
95298186Sgordon	esac
95398186Sgordon}
95498186Sgordon
95598186Sgordon#
95698186Sgordon# backup_file action file cur backup
95798186Sgordon#	Make a backup copy of `file' into `cur', and save the previous
95898186Sgordon#	version of `cur' as `backup' or use rcs for archiving.
95998186Sgordon#
96098186Sgordon#	This routine checks the value of the backup_uses_rcs variable,
96198186Sgordon#	which can be either YES or NO.
96298186Sgordon#
96398186Sgordon#	The `action' keyword can be one of the following:
96498186Sgordon#
96598186Sgordon#	add		`file' is now being backed up (and is possibly
96698186Sgordon#			being reentered into the backups system).  `cur'
96798186Sgordon#			is created and RCS files, if necessary, are
96898186Sgordon#			created as well.
96998186Sgordon#
97098186Sgordon#	update		`file' has changed and needs to be backed up.
97198186Sgordon#			If `cur' exists, it is copied to to `back' or
97298186Sgordon#			checked into RCS (if the repository file is old),
97398186Sgordon#			and then `file' is copied to `cur'.  Another RCS
97498186Sgordon#			check in done here if RCS is being used.
97598186Sgordon#
97698186Sgordon#	remove		`file' is no longer being tracked by the backups
97798186Sgordon#			system.  If RCS is not being used, `cur' is moved
97898186Sgordon#			to `back', otherwise an empty file is checked in,
97998186Sgordon#			and then `cur' is removed.
98098186Sgordon#
98198186Sgordon#
98298186Sgordonbackup_file()
98398186Sgordon{
98498186Sgordon	_action=$1
98598186Sgordon	_file=$2
98698186Sgordon	_cur=$3
98798186Sgordon	_back=$4
98898186Sgordon
98998186Sgordon	if checkyesno backup_uses_rcs; then
99098186Sgordon		_msg0="backup archive"
99198186Sgordon		_msg1="update"
99298186Sgordon
99398186Sgordon		# ensure that history file is not locked
99498186Sgordon		if [ -f $_cur,v ]; then
99598186Sgordon			rcs -q -u -U -M $_cur
99698186Sgordon		fi
99798186Sgordon
99898186Sgordon		# ensure after switching to rcs that the
99998186Sgordon		# current backup is not lost
100098186Sgordon		if [ -f $_cur ]; then
100198186Sgordon			# no archive, or current newer than archive
100298186Sgordon			if [ ! -f $_cur,v -o $_cur -nt $_cur,v ]; then
100398186Sgordon				ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
100498186Sgordon				rcs -q -kb -U $_cur
100598186Sgordon				co -q -f -u $_cur
100698186Sgordon			fi
100798186Sgordon		fi
100898186Sgordon
100998186Sgordon		case $_action in
101098186Sgordon		add|update)
101198186Sgordon			cp -p $_file $_cur
101298186Sgordon			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
101398186Sgordon			rcs -q -kb -U $_cur
101498186Sgordon			co -q -f -u $_cur
101598186Sgordon			chown root:wheel $_cur $_cur,v
101698186Sgordon			;;
101798186Sgordon		remove)
101898186Sgordon			cp /dev/null $_cur
101998186Sgordon			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
102098186Sgordon			rcs -q -kb -U $_cur
102198186Sgordon			chown root:wheel $_cur $_cur,v
102298186Sgordon			rm $_cur
102398186Sgordon			;;
102498186Sgordon		esac
102598186Sgordon	else
102698186Sgordon		case $_action in
102798186Sgordon		add|update)
102898186Sgordon			if [ -f $_cur ]; then
102998186Sgordon				cp -p $_cur $_back
103098186Sgordon			fi
103198186Sgordon			cp -p $_file $_cur
103298186Sgordon			chown root:wheel $_cur
103398186Sgordon			;;
103498186Sgordon		remove)
103598186Sgordon			mv -f $_cur $_back
103698186Sgordon			;;
103798186Sgordon		esac
103898186Sgordon	fi
103998186Sgordon}
1040119166Smtm
1041123344Smtm# make_symlink src link
1042123344Smtm#	Make a symbolic link 'link' to src from basedir. If the
1043123344Smtm#	directory in which link is to be created does not exist
1044123344Smtm#	a warning will be displayed and an error will be returned.
1045123344Smtm#	Returns 0 on sucess, 1 otherwise.
1046119166Smtm#
1047123344Smtmmake_symlink()
1048119166Smtm{
1049123344Smtm	local src link linkdir _me
1050123344Smtm	src="$1"
1051123344Smtm	link="$2"
1052123344Smtm	linkdir="`dirname $link`"
1053123344Smtm	_me="make_symlink()"
1054119166Smtm
1055123344Smtm	if [ -z "$src" -o -z "$link" ]; then
1056123344Smtm		warn "$_me: requires two arguments."
1057119166Smtm		return 1
1058119166Smtm	fi
1059123344Smtm	if [ ! -d "$linkdir" ]; then
1060123344Smtm		warn "$_me: the directory $linkdir does not exist"
1061119166Smtm		return 1
1062119166Smtm	fi
1063119166Smtm	if ! ln -sf $src $link ; then
1064123344Smtm		warn "$_me: unable to make a symbolic link from $link to $src"
1065119166Smtm		return 1
1066119166Smtm	fi
1067119166Smtm	return 0
1068119166Smtm}
1069119166Smtm
1070119166Smtm# devfs_rulesets_from_file file
1071119166Smtm#	Reads a set of devfs commands from file, and creates
1072119166Smtm#	the specified rulesets with their rules. Returns non-zero
1073119166Smtm#	if there was an error.
1074119166Smtm#
1075119166Smtmdevfs_rulesets_from_file()
1076119166Smtm{
1077119166Smtm	local file _err _me
1078119166Smtm	file="$1"
1079119166Smtm	_me="devfs_rulesets_from_file"
1080119166Smtm	_err=0
1081119166Smtm
1082119166Smtm	if [ -z "$file" ]; then
1083119166Smtm		warn "$_me: you must specify a file"
1084119166Smtm		return 1
1085119166Smtm	fi
1086119166Smtm	if [ ! -e "$file" ]; then
1087119166Smtm		debug "$_me: no such file ($file)"
1088119166Smtm		return 0
1089119166Smtm	fi
1090119166Smtm	debug "reading rulesets from file ($file)"
1091119166Smtm	{ while read line
1092119166Smtm	do
1093119166Smtm		case $line in
1094119166Smtm		\#*)
1095119166Smtm			continue
1096119166Smtm			;;
1097119166Smtm		\[*\]*)
1098119166Smtm			rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1099119166Smtm			if [ -z "$rulenum" ]; then
1100119166Smtm				warn "$_me: cannot extract rule number ($line)"
1101119166Smtm				_err=1
1102119166Smtm				break
1103119166Smtm			fi
1104119166Smtm			rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1105119166Smtm			if [ -z "$rulename" ]; then
1106119166Smtm				warn "$_me: cannot extract rule name ($line)"
1107119166Smtm				_err=1
1108119166Smtm				break;
1109119166Smtm			fi
1110119166Smtm			eval $rulename=\$rulenum
1111119166Smtm			debug "found ruleset: $rulename=$rulenum"
1112119166Smtm			if ! /sbin/devfs rule -s $rulenum delset ; then
1113119166Smtm				_err=1
1114119166Smtm				break
1115119166Smtm			fi
1116119166Smtm			;;
1117119166Smtm		*)
1118119166Smtm			rulecmd="${line%%"\#*"}"
1119119166Smtm			# evaluate the command incase it includes
1120119166Smtm			# other rules
1121119166Smtm			if [ -n "$rulecmd" ]; then
1122119166Smtm				debug "adding rule ($rulecmd)"
1123119166Smtm				if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1124119166Smtm				then
1125119166Smtm					_err=1
1126119166Smtm					break
1127119166Smtm				fi
1128119166Smtm			fi
1129119166Smtm			;;
1130119166Smtm		esac
1131119166Smtm		if [ $_err -ne 0 ]; then
1132119166Smtm			debug "error in $_me"
1133119166Smtm			break
1134119166Smtm		fi
1135119166Smtm	done } < $file
1136119166Smtm	return $_err
1137119166Smtm}
1138119166Smtm
1139119166Smtm# devfs_init_rulesets
1140119166Smtm#	Initializes rulesets from configuration files. Returns
1141119166Smtm#	non-zero if there was an error.
1142119166Smtm#
1143119166Smtmdevfs_init_rulesets()
1144119166Smtm{
1145119166Smtm	local file _me
1146119166Smtm	_me="devfs_init_rulesets"
1147119166Smtm
1148119166Smtm	# Go through this only once
1149119166Smtm	if [ -n "$devfs_rulesets_init" ]; then
1150119166Smtm		debug "$_me: devfs rulesets already initialized"
1151119166Smtm		return
1152119166Smtm	fi
1153119166Smtm	for file in $devfs_rulesets ; do
1154119166Smtm		devfs_rulesets_from_file $file || return 1
1155119166Smtm	done
1156119166Smtm	devfs_rulesets_init=1
1157119166Smtm	debug "$_me: devfs rulesets initialized"
1158119166Smtm	return 0
1159119166Smtm}
1160119166Smtm
1161119166Smtm# devfs_set_ruleset ruleset [dir]
1162119166Smtm#	Sets the default ruleset of dir to ruleset. The ruleset arguement
1163119166Smtm#	must be a ruleset name as specified in devfs.rules(5) file.
1164119166Smtm#	Returns non-zero if it could not set it successfully.
1165119166Smtm#
1166119166Smtmdevfs_set_ruleset()
1167119166Smtm{
1168119166Smtm	local devdir rs _me
1169119166Smtm	[ -n "$1" ] && eval rs=\$$1 || rs=
1170119166Smtm	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1171119166Smtm	_me="devfs_set_ruleset"
1172119166Smtm
1173119166Smtm	if [ -z "$rs" ]; then
1174119166Smtm		warn "$_me: you must specify a ruleset number"
1175119166Smtm		return 1
1176119166Smtm	fi
1177119166Smtm	debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1178119166Smtm	if ! /sbin/devfs $devdir ruleset $rs ; then
1179119166Smtm		warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1180119166Smtm		return 1
1181119166Smtm	fi
1182119166Smtm	return 0
1183119166Smtm}
1184119166Smtm
1185119166Smtm# devfs_apply_ruleset ruleset [dir]
1186119166Smtm#	Apply ruleset number $ruleset to the devfs mountpoint $dir.
1187119166Smtm#	The ruleset argument must be a ruleset name as specified
1188119166Smtm#	in a devfs.rules(5) file.  Returns 0 on success or non-zero
1189119166Smtm#	if it could not apply the ruleset.
1190119166Smtm#
1191119166Smtmdevfs_apply_ruleset()
1192119166Smtm{
1193119166Smtm	local devdir rs _me
1194119166Smtm	[ -n "$1" ] && eval rs=\$$1 || rs=
1195119166Smtm	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1196119166Smtm	_me="devfs_apply_ruleset"
1197119166Smtm
1198119166Smtm	if [ -z "$rs" ]; then
1199119166Smtm		warn "$_me: you must specify a ruleset"
1200119166Smtm		return 1
1201119166Smtm	fi
1202119166Smtm	debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1203119166Smtm	if ! /sbin/devfs $devdir rule -s $rs applyset ; then
1204119166Smtm		warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1205119166Smtm		return 1
1206119166Smtm	fi
1207119166Smtm	return 0
1208119166Smtm}
1209119166Smtm
1210119166Smtm# devfs_domount dir [ruleset]
1211119166Smtm#	Mount devfs on dir. If ruleset is specified it is set
1212119166Smtm#	on the mount-point. It must also be a ruleset name as specified
1213119166Smtm#	in a devfs.rules(5) file. Returns 0 on success.
1214119166Smtm#
1215119166Smtmdevfs_domount()
1216119166Smtm{
1217119166Smtm	local devdir rs _me
1218119166Smtm	devdir="$1"
1219119166Smtm	[ -n "$2" ] && rs=$2 || rs=
1220119166Smtm	_me="devfs_domount()"
1221119166Smtm
1222119166Smtm	if [ -z "$devdir" ]; then
1223119166Smtm		warn "$_me: you must specify a mount-point"
1224119166Smtm		return 1
1225119166Smtm	fi
1226119166Smtm	debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1227119166Smtm	if ! mount -t devfs dev "$devdir" ; then
1228119166Smtm		warn "$_me: Unable to mount devfs on $devdir"
1229119166Smtm		return 1
1230119166Smtm	fi
1231119166Smtm	if [ -n "$rs" ]; then
1232119166Smtm		devfs_init_rulesets
1233119166Smtm		devfs_set_ruleset $rs $devdir
1234119166Smtm	fi
1235119166Smtm	return 0
1236119166Smtm}
1237119166Smtm
1238119166Smtm# devfs_mount_jail dir [ruleset]
1239119166Smtm#	Mounts a devfs file system appropriate for jails
1240119166Smtm#	on the directory dir. If ruleset is specified, the ruleset
1241119166Smtm#	it names will be used instead.  If present, ruleset must
1242119166Smtm#	be the name of a ruleset as defined in a devfs.rules(5) file.
1243119166Smtm#	This function returns non-zero if an error occurs.
1244119166Smtm#
1245119166Smtmdevfs_mount_jail()
1246119166Smtm{
1247119166Smtm	local jdev rs _me
1248119166Smtm	jdev="$1"
1249119166Smtm	[ -n "$2" ] && rs=$2 || rs="devfsrules_jail"
1250119166Smtm	_me="devfs_mount_jail"
1251119166Smtm
1252119166Smtm	devfs_init_rulesets
1253119166Smtm	if ! devfs_domount "$jdev" $rs ; then
1254119166Smtm		warn "$_me: devfs was not mounted on $jdev"
1255119166Smtm		return 1
1256119166Smtm	fi
1257119166Smtm	return 0
1258119166Smtm}
1259